/*"Cliente" simula un processo che e' intenzionato ad usare la riosrsa.
Segnala la prorpia volonta' di prenotarsi al gestore del suo nodo (con una IPC)
indicando la porta che ha messo a disposizione per ricevere la connessione dal coordinatore.Resta quindi in attesa del prorpio turno.Al risveglio riceve l'endpoint per inviare la richiesta alla risorsa*/

#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>
#include <sys/ipc.h>
#include <sys/stat.h>
#define LEN 50
#define RISP 10
typedef struct {u_short len; char name[6];} Request;
typedef struct {u_short sin_port;u_long sin_addr;} Token_format; /*size=6*/
typedef struct hostent Hostent;
typedef char *service;
int errno;


void hand(int signo)	
 {			 	
int stato;
wait(&stato);
 }

int recv_string (int h,char *req) 
{int r_bytes,n;
 int len=sizeof(*req);
 for(r_bytes=0;r_bytes<len;r_bytes+=n)
 { n=recv(h,((char*)req)+r_bytes,len-r_bytes,0);
   if (n<=0) return n;
  }
printf("\nHo ricevuto  :(%s) ",req);
return r_bytes;
}


int create_server_endpoint(int port)
{
struct sockaddr_in addr;
int h;

h=socket(AF_INET,SOCK_STREAM,0);
memset((void*)&addr,0,sizeof(addr));
addr.sin_family=AF_INET;
addr.sin_port=htons(port);
addr.sin_addr.s_addr=INADDR_ANY;
if(bind(h,(struct sockaddr*)&addr,sizeof(addr))<0)
   {
  perror("bind");
  return -1;
    }
listen(h,5);
return h;
}



int recv_token(int h,Token_format *tkin) 
{
int r_bytes,n,len=sizeof(Token_format);
      
     for(r_bytes=0;r_bytes<len;r_bytes+=n)
      { n=recv(h,((char*)tkin)+r_bytes,len-r_bytes,0);
        if (n<=0) return n;
      }
}

int send_token(int h, Token_format *risp)
{ Token_format rispo;
  int lung,w_bytes,n;

   rispo=*risp;
   lung=sizeof(rispo);
   printf("\nInizio a spedire al gestore (rispo.sin_addr=%d) e (rispo.sin_port=%d)\n",rispo.sin_addr,rispo.sin_port); 

for(w_bytes=0;w_bytes<lung;w_bytes+=n)
   n=send(h,((char*)&rispo)+w_bytes,lung-w_bytes,0);

 return(n);
}




int create_nexthost_endpoint(int port, char *nomehp)
{struct sockaddr_in addr;
 struct hostent *hp;
int h;
hp=(Hostent *)malloc(1);
h=socket(AF_INET,SOCK_STREAM,0);
if(h==-1)
{  fprintf(stderr,"Impossibile aprire socket \n");
   fflush(stdout); 
   return 0;
}
hp=gethostbyname(nomehp);
if(hp==NULL)
   {fprintf(stderr,"%s non trovato in /etc/hosts\n",nomehp);
    fflush(stdout); 
    return 0;
   }

memset((void*)&addr,0,sizeof(addr));
addr.sin_family=AF_INET;
addr.sin_port=htons(port);
addr.sin_addr.s_addr=((struct in_addr*)(hp->h_addr))->s_addr;
if(connect(h,(struct sockaddr*)&addr,sizeof(struct sockaddr_in))==-1)
{  fprintf(stderr,"Impossibile connettersi \n");
   fflush(stdout); 
   return 0;
}
 printf("\nSono in create_nexthost_endpoint mi sono collegato sulla porta=%u",addr.sin_port);
 return h;
}

int converti(char *buf,int step)
{int i;char *ris;
  ris=(char *)malloc(step);
  for(i=0;i<step;i++) ris[i]=buf[i];
  return (atoi(ris));
}


main()
{			  
int pidn,nr,ns,nrisorsa,i,nporta=0,listener=-1,h,addrlen;
char *buf,*ris;
Token_format *ep;
struct sockaddr_in peeraddr_in;
service serv;
Request richiesta;
Token_format req,risp;

serv=(char *)malloc(80);
buf=(char *)malloc(80);
ris=(char *)malloc(80);
ep=(Token_format *)malloc(1);
 memset((char*)&peeraddr_in,0,sizeof(struct sockaddr_in));

pidn=open("book",O_RDWR|O_APPEND);
if(pidn<=0){perror("open");}
fcntl(pidn,F_SETFL,O_NONBLOCK);
printf("\nDigita l'indirizzo:");
scanf("%s",ris);
strcpy(richiesta.name,ris);
while(listener<0)
  {
printf("\nDigita il n.ro di porta:");
scanf("%d",&nporta);
richiesta.len=nporta;
if(nporta!=1)
 {
listener=create_server_endpoint(nporta); 
if(listener<0) printf("\nImpossibile usare la porta %d",nporta);
 
  }
else listener=1;     
  }
sprintf(buf,"%s%d",richiesta.name,richiesta.len);
if(write(pidn,buf,10)<0)
	 {perror("Write");
          exit(0);}
printf("\nMi metto in attesa del mio turno"); 
sleep(10);
if(nporta==1) exit(0);
h=accept(listener,0,0);
printf("Mi sono risvegliato\n");	

if((nr=recv_token(h,ep))<=0) printf("problemi nella ricezione del permesso");

if(ep->sin_addr<=9) sprintf(ris,"lia0%d",ep->sin_addr);
 else sprintf(ris,"lia%d",ep->sin_addr);
printf("\nChiedo di essere servito alla risorsa ubicata su lia%d e porta %d\n",ep->sin_addr,ep->sin_port);
if ((nrisorsa=create_nexthost_endpoint(ep->sin_port,ris))>0) /*si collega con il nexthost*/
      { getsockname(nrisorsa,(struct sockaddr*)&peeraddr_in,&addrlen);
        printf("\nMi sono collegato con la risorsa sulla porta=%u",peeraddr_in.sin_port);
      }
 else {printf("\nimpossibile raggiungere la risorsa\n");
       exit(-1);}
serv="richiesta1";
req.sin_port=ep->sin_port;
req.sin_addr=ep->sin_addr;
printf("\nMando al gestore la richiesta (req.sin_port=%d) (req.sin_addr=%d)",req.sin_port,req.sin_addr);
if(send_token(nrisorsa,&req)<=0) printf("Non sono riuscito ad inviare la richiesta di servizio\n");
else if(recv_token(nrisorsa,&risp)<=0) perror("\nproblemi nella connessione con la risorsa.\nEsco"); 
     else {printf("\nServizio soddisfatto con (risp.sin_port=%d)  (risp.sin_addr=%d)",risp.sin_port,risp.sin_addr);

/*Eventuale trattazione dell'esito della risposta e riinvi.
da modificare facendo in modo che in caso di sblocco dovuto ad un segnale si rimetta in attesa di ricevere, e aggiungere dei time-out*/
shutdown(nrisorsa,2);
shutdown(h,2);
          }
close(pidn);
}


