/*E' il gestore presente su ogni nodo che si occupa di gestire il token e di  raccogliere le richieste  del proprio nodo (tramite IPC) ed inserirle nel token.
Deve inoltre:
.controllare lo stato del nodo a lui collegato segnalando eventuali anomalie con token di controllo.
.gestire il protocollo di recovery in base alle informazioni che gli giungono.
.gestire il protocollo di inserimento qualora il coordinatore decida di modificareuno dei suoi vicini.
*/
#include <sys/types.h>
#include <sys/socket.h>
#include <errno.h>
#include <netinet/in.h>
#include <stdio.h>
#include <netdb.h>
#include <signal.h>
#include <fcntl.h>
#include <stdlib.h>
/*#include <unistd.h>*/
#include <sys/ipc.h>
#include <sys/stat.h>

#define LEN 50

typedef struct {u_short len; char name[5];} Request;
typedef struct {u_short sin_port; u_long sin_addr;} Token_format;   
typedef struct {u_short stato; u_short numelem;u_long tkid;} Dimtoken_format;
typedef struct hostent Hostent;
typedef int HANDLE;
Request myhost,nextnodo; 

Token_format arraytoken[LEN],arraytoken_new[LEN],primotoken[LEN],insertoken[2],tkapp[LEN];
long ciclo,dimtoken,dimtoken1,idtoken=0,dimapp=0;
u_long indirizzo;
u_short mylen,nextlen,inserimento=0;
int nextsd,nextsd1,statotoken=0,sendtknew=0,xret=0,in_new_token,ok_token,rcvtk,changecon=0,ioout=0,precusc=0,cambiato_nextsd=0,crash=0;


  /*FUNZIONE*/

void gest(int signo)
  {
int status;
wait(&status);
  }
 
HANDLE create_server_endpoint(int port)
{
struct sockaddr_in addr;
static HANDLE h;

h=socket(AF_INET,SOCK_STREAM,0);
if(h<=0) perror("Non riesco a creare la socket per la ricezione del token");
memset((void*)&addr,0,sizeof(addr));
addr.sin_family=AF_INET;
addr.sin_port=htons(port);
addr.sin_addr.s_addr=INADDR_ANY;
if(bind(h,(struct sockaddr*)&addr,sizeof(addr))!=0)
    {
    perror("problemi con la bind per la ricezione del token");
    }	
if(listen(h,5)!=0) perror("problemi con la listen");
return h;
}



HANDLE create_nexthost_endpoint(int port, char *nomehp)
{struct sockaddr_in addr;
 struct hostent *hp;
 HANDLE h,error;

hp=(Hostent *)malloc(sizeof(Hostent));
h=socket(AF_INET,SOCK_STREAM,0);
if(h==-1)
{  fprintf(stderr,"Impossibile aprire socket \n");
   fflush(stdout); 
   return 0;
}
printf("tento collegamento a %s\n",nomehp);
hp=gethostbyname(nomehp);
if(hp==NULL)
   {fprintf(stderr,"%s non trovato in /etc/hosts\n",nomehp);
    fflush(stdout); 
    return 0;
   }

memset((void*)&addr,0,sizeof(addr));
addr.sin_family=AF_INET;
addr.sin_port=htons(port);
addr.sin_addr.s_addr=((struct in_addr*)(hp->h_addr))->s_addr;
error=-1;
while (error==-1) 
   { 
   error=connect(h,(struct sockaddr*)&addr,sizeof(struct sockaddr_in));
   if(error==1) perror("Problemi connect: ritento");
}
printf("Mi sono connesso su %d con socket %d",addr.sin_port,h);
 
return h;
}

 
   
int converti(char *buf,int step)
{ static int i;
  char *ris,app5[5],app2[2];

  ris=(char *)malloc(step);
  if(step==2)
   {
  for(i=0;i<step;i++) app2[i]=buf[i];
       sprintf(ris,"%s",app2);       

   }
  else {
       for(i=0;i<step;i++) app5[i]=buf[i];
       sprintf(ris,"%s",app5);       
       }
  return (atoi(ris));
}


 
 int handle_new_tok(HANDLE h, HANDLE nexth)
{ Token_format *tkin,*tkout;/*puntatori al token da ricevere e spedire*/
  static int ret=0,i;
 
  
  tkin=(Token_format *)malloc(sizeof(Token_format));
  tkin=arraytoken_new;
  if((ret=recv_token(h,tkin))<=0) {printf("\nhandle tok ritorna %d",ret);
				   ret=-1;
                                   return ret;}
  printf("\nHo ricevuto il token dalla nuova connessione\n");
  if (in_new_token!=dimtoken1)
     {printf("\n   I due token hanno dimensioni diverse! %d  %d",in_new_token,dimtoken1);
      ret=-1;
     }
  else
  for (i=0;i<dimtoken1;i++)
   if ((primotoken[i].sin_port != arraytoken_new[i].sin_port)||(primotoken[i].sin_addr != arraytoken_new[i].sin_addr))   
         { printf("\ni due token sono diversi nella posizione %d:\n %d vs %d",i,primotoken[i].sin_port,arraytoken_new[i].sin_port);
           ret=-2;
         }
    if ((ret!=-1)&&(ret!=-2)) {printf("\nI due token sono uguali");  inserimento=0;statotoken=0;}
    return ret; 
}


/*FUNZIONE che manipola il token (ci inserira' le richieste dei processi del suo nodo)*/

int raccogli_richieste(Token_format *tkin,int dim)
    {
char *pren;
int b,i,nread;


pren=(char *)malloc(80);
b=open("book",O_RDWR|O_APPEND);
if(b<=0){perror("open");}
fcntl(b,F_SETFL,O_NONBLOCK);
if(inserimento==2) printf("Il servizio delle eventuali richieste verra' posticipato\n");
for(;(nread=read(b,pren,10)>0);dim++)
 {
    tkin[dim].sin_addr=converti((pren+3),2); 
    tkin[dim].sin_port=converti((pren+5),5);
    printf("\nCi sono le richieste da lia%d porta%d\n",tkin[dim].sin_addr,tkin[dim].sin_port);  
    if(tkin[dim].sin_port==1) {
				printf("Voglio uscire dal ring\n");
				dim--;
				ioout=1;
			       }	    
  }
close(b);
return(dim);
}

 liaxx(int ind,char buf[5])
     {
 if(ind<=9) sprintf(buf,"lia0%d",ind);
	else sprintf(buf,"lia%d",ind);
     }	


Token_format *azione_token(Token_format *tkin)
{  Token_format app;
   int i,nextname,myname,ret;
   char buf[5];

   for(i=0;i<dimtoken;i++)
   printf("\n(%d) Elemento porta=%u   indirizzo=%u",i,arraytoken[i].sin_port,arraytoken[i].sin_addr);
      nextname=converti((nextnodo.name+3),2);
      myname=converti((myhost.name+3),2);	

     if (statotoken==1)
     {
      printf("\nControllo se sono interessato all'inserimento");
      printf("\nIl primo nodo interessato e': lia%d  porta=%d",arraytoken[0].sin_addr,arraytoken[0].sin_port);
printf("\nIl nodo da inserire e': lia%d  porta=%d",arraytoken[1].sin_addr,arraytoken[1].sin_port);
     
     if((mylen==arraytoken[0].sin_port)&&(myname==arraytoken[0].sin_addr))
       { 
         printf("\nSono interessato all'inserimento come secondo elemento!\nDovro' ricevere una nuova connessione\n");
            inserimento=2;
            insertoken[0].sin_port=arraytoken[0].sin_port;
            insertoken[0].sin_addr=arraytoken[0].sin_addr;
            insertoken[1].sin_port=arraytoken[1].sin_port;
            insertoken[1].sin_addr=arraytoken[1].sin_addr;
    /*lo useremo per il confronto con il primo token che arrivera' da rcvtk1 */
            in_new_token=dimtoken;
	   for(ret=0;ret<dimtoken;ret++)
	   { primotoken[ret].sin_port=arraytoken[ret].sin_port;
	     primotoken[ret].sin_addr=arraytoken[ret].sin_addr;
	   }
       } 
     if((nextlen==arraytoken[0].sin_port)&&(nextname==arraytoken[0].sin_addr))
       { inserimento=1;
         printf("\nSono interessato all'inserimento devo cambiare l'istradamento\n");
         insertoken[0].sin_port=arraytoken[0].sin_port;/*e' l'endpoint del mio vicino nel ring*/
         insertoken[0].sin_addr=arraytoken[0].sin_addr;
         insertoken[1].sin_port=arraytoken[1].sin_port;/*e' l'endpoint a cui mandare il token*/
         insertoken[1].sin_addr=arraytoken[1].sin_addr;
       }
     }

   if(inserimento==2) {
  			dimapp=raccogli_richieste(tkapp,dimapp);
			printf("inserimento=2 quindi servizio sospeso per le %d richieste\n",dimapp);
			}
   else {		
         for(i=0;i<dimapp;i++)
		{	
		tkin[dimtoken].sin_addr=tkapp[i].sin_addr; 
    		tkin[dimtoken].sin_port=tkapp[i].sin_port;
		dimtoken++;
		printf("ho aggiunto la richiesta vecchia:: lia%d %d\n",tkin[dimtoken-1].sin_addr,tkin[dimtoken-1].sin_port);
		}
         dimtoken=raccogli_richieste(tkin,dimtoken);
	 dimapp=0;	
	}
   if((statotoken==0)&&(ioout==1)) /*voglio uscire*/
	{
        arraytoken[0].sin_port=mylen;	
	arraytoken[0].sin_addr=myname;
	arraytoken[1].sin_port=nextlen;
	arraytoken[1].sin_addr=nextname;
	}
    if(statotoken==2)   /*nodo precedente esce*/
		if(precusc==1) 
			{
			precusc=0;
			arraytoken[0].sin_port=0;
			arraytoken[0].sin_addr=0;
			arraytoken[1].sin_port=0;
			arraytoken[1].sin_addr=0;
			statotoken=0;
			}
		else	
		   {
		  printf("Esce %d - e interessa %d lia%d, io sono %d %d\n",arraytoken[0].sin_port,arraytoken[1].sin_port,arraytoken[1].sin_addr,mylen,myname);		
		  if((mylen==arraytoken[1].sin_port)&&(myname==arraytoken[1].sin_addr))
			{
			printf("Il nodo che mi precede vuole uscire dal ring\n");	
			precusc=1;
			}
		  if((nextlen==arraytoken[0].sin_port)&&(nextname==arraytoken[0].sin_addr))
			{
			printf("Il nodo successivo vuole uscire dal ring\n");
			close(nextsd);	
		        if ((arraytoken[1].sin_addr)<=9)  sprintf(buf,"lia%d%d",0,arraytoken[1].sin_addr);
          		else sprintf(buf,"lia%d",arraytoken[1].sin_addr);
		   	nextsd=create_nexthost_endpoint(arraytoken[1].sin_port,buf);
                        cambiato_nextsd=1;
			printf(" Il nuovo nodo a cui sono connesso e' lia%d %d\n",arraytoken[1].sin_addr,arraytoken[1].sin_port);  
                        /*aggiorno l'endpoint del mio successivo*/
                        nextlen=arraytoken[1].sin_port;
                        nextname=arraytoken[1].sin_addr;
			nextnodo.len=nextlen;
			liaxx(nextname,nextnodo.name);
			}
                   }

   return(tkin);
}


int send_token(HANDLE h, Token_format *tkout)
{ Dimtoken_format dimout;
  int lung,w_bytes;
  static int n;

  if((statotoken==0)&&(ioout)) statotoken=2;
  dimout.stato=statotoken;    
  dimout.numelem=dimtoken; 
  dimout.tkid=idtoken+dimtoken-2;
  lung=sizeof(dimout);
  if((ok_token)||(changecon)){dimout.stato=statotoken=0;}
  if (h!=nextsd) dimout.stato=0;
  printf("\nSpedisco la dimensione del token=%d e lo stato %d\n",lung,statotoken); 
  for(w_bytes=0;w_bytes<lung;w_bytes+=n)
     n=send(h,((char*)&dimout)+w_bytes,lung-w_bytes,0);
  if(n!=lung) { printf("\nProblemi per spedire la dimensione del token -> Recovery");
                return(-1);
              }
  else
  { 
    lung=sizeof(*tkout)*dimtoken;
    printf("\nSpedisco il Token"); 

    for(w_bytes=0;w_bytes<lung;w_bytes+=n)
        n=send(h,((char*)tkout)+w_bytes,lung-w_bytes,0);
  
    if(n!=lung) { printf("\nProblemi per spedire il token -> Recovery");
                  return(-1);
                }
   
    else return(n);
  }
}





/*Funzione che riceve la dimensione del token*/

int recv_dimtoken(HANDLE h,Dimtoken_format *req) 
{
int r_bytes,n;
int len=sizeof(*req);

for(r_bytes=0;r_bytes<len;r_bytes+=n)
{ n=recv(h,((char*)req)+r_bytes,len-r_bytes,0);
if (n<=0) {if(n<0) perror("\nNon riesco a ricevere la dimensione del token");
	   else printf("\nNon riesco a ricevere la dimensione del token n=%d",n);
	   return n;
	   }
}
if(req->stato!=3) 
{statotoken=ntohl(req->stato);
idtoken=ntohl(req->tkid);
 } 
if(changecon) statotoken=0;
dimtoken=ntohl(req->numelem);
return r_bytes;
}

   
int recv_token(HANDLE h,Token_format *tkin) 
{
int r_bytes,n,numelem;
u_short i;
int len=sizeof(*tkin)*dimtoken;
   
    for(r_bytes=0;r_bytes<len;r_bytes+=n)
      { n=recv(h,((char*)tkin)+r_bytes,len-r_bytes,0);
        if (n<=0) return n;
      }
       
  return (r_bytes);
}


 int send_token3(HANDLE h, Token_format *tkout)		
{ Dimtoken_format dimout;
  int lung,w_bytes;
  static int n;

  dimout.stato=3;    
  dimout.numelem=2; 
  dimout.tkid=-1;
  lung=sizeof(dimout);
   printf("\nSpedisco la dimensione del token=%d di segnalazione di possibili crash con stato %d\n",lung,statotoken); 
  for(w_bytes=0;w_bytes<lung;w_bytes+=n)
     n=send(h,((char*)&dimout)+w_bytes,lung-w_bytes,0);
  if(n!=lung) { printf("\nProblemi per spedire la dimensione del token -> Recovery");
                return(-1);
              }
  else
  { 
    lung=sizeof(*tkout)*dimtoken;
    printf("\nSpedisco il Token"); 

    for(w_bytes=0;w_bytes<lung;w_bytes+=n)
        n=send(h,((char*)tkout)+w_bytes,lung-w_bytes,0);
  
    if(n!=lung) { printf("\nProblemi per spedire il token -> Recovery");
                  return(-1);
                }
   
    else return(n);
  }
}


int handletok(HANDLE h, HANDLE nexth)
 { Token_format *tkin,*tkout;/*puntatori al token da ricevere e spedire*/
   char nomehp[5];
   int apposd,ret,y=0,k;

   tkin=(Token_format *)malloc(sizeof(Token_format));
   tkout=(Token_format *)malloc(sizeof(Token_format));
   if (crash==0) tkin=arraytoken;
   if((ret=recv_token(h,tkin))<=0) {printf("\nhandletok ritorna %d",ret);
			            return ret;
				    }
   if(crash==2)			
	{
	printf("\n1)lia%d %d\n",tkin->sin_addr,tkin->sin_port);
	printf("controllo se sono interessato lia%d %d...",(tkin+1)->sin_addr,(tkin+1)->sin_port);
        if((mylen==(tkin+1)->sin_port)&&(converti((myhost.name+3),2)==(tkin+1)->sin_addr))
		{
		liaxx(tkin->sin_addr,nomehp);
		nextsd=create_nexthost_endpoint(tkin->sin_port,nomehp);
		printf("Recovery da crash riuscita\nconnesso a %s %d con connessione %d\n",nomehp,tkin->sin_port,nextsd);
 		nextlen=tkin->sin_port;
	        nextnodo.len=nextlen;
		strcpy(nextnodo.name,nomehp);
                nexth=nextsd;
		cambiato_nextsd=1;
		}
        else return send_token3(nexth,tkin);		
	}
if(crash==0)
   {
   printf("\nE' ritornato il (%d) TOKEN  dalla connessione=%d",idtoken,h);
   tkout=azione_token(tkin);
   }	
   if (cambiato_nextsd) { printf("\nCambio connessione %d-->%d=nextsd\nInvio al nuovo nodo",nexth,nextsd);
                          nexth=nextsd;
                          cambiato_nextsd=0;
                        }
   k=send_token(nexth,tkout);
   if((statotoken==1)&&(!xret)) xret=k;
   ret=k;         
      if (inserimento==1)
          { 
 	  printf("\nInizio il cambiamento dell'istradamento del token");
          printf("\nDA lia%d porta=%d",insertoken[0].sin_addr,insertoken[0].sin_port);
	  printf(" A lia%d porta=%d",insertoken[1].sin_addr,insertoken[1].sin_port);

          if ((insertoken[1].sin_addr)<=9)  sprintf(nomehp,"lia%d%d",0,insertoken[1].sin_addr);
          else sprintf(nomehp,"lia%d",insertoken[1].sin_addr);
	  if(nextsd1==0) if((nextsd1=create_nexthost_endpoint(insertoken[1].sin_port,nomehp))<0)
			  printf("\n Non riesco a collegarmi"); 
			 /*recovery*/
          if((nextsd1>0)&&(sendtknew==0))          
               	{ 
   	        printf("\n Invio il token al nuovo nodo sulla connessione %d",nextsd1);
	        y=send_token(nextsd1,tkout);
		sendtknew=y;
	        if((inserimento!=1)||((inserimento==1)&&(xret==y))) ret=xret;  /*tutto ok*/
   		else if((y!=xret)&&(xret>0)) ret=-10;      /* problemi solo sulla nuova connessione (si assume che la vecchia connessione sia piu' affidabile)*/
        	     else if((xret<=0)&&(y>=0)) ret=-20; /*problemi solo sulla vecchia connessione*/
	                  else ret=-30;        /*x<=0 and y<=0 problemi su entrambe le connessioni*/ 
		 xret=0;
  	         }
	    }	                      
   return(ret);
  }



int handledim(HANDLE h, HANDLE nexth)
{ Dimtoken_format req;
  static int ret;
	
   if ((ret=recv_dimtoken(h,&req))<=0) 
	{
        printf("\ndimensione del token=%d",req.numelem);
       if(statotoken!=2){ printf("\nhandle dim ritorna %d",ret);
			  if(ret==0) printf(" connessione chiusa");
			}
	return ret;			
	}
if(req.tkid>=0)
  {
  if(req.stato==3)
		{
		crash=2;		
		printf("Possibili problemi nel ring stato=3\n");
		return ret;
		}
  else crash=0; /*crash=0 token normale
                  crash=1 problemi con il mio precedente invio segnalazione di guasto		  
		  crash=2  segnalazione esterna di un crash nel ring*/
  printf("\nHo ricevuto la dimensione del %d token e vale (%u)",req.tkid,req.numelem);
  printf("\ned anche il suo stato=(%u)",req.stato);
  if(h!=rcvtk)  dimtoken1=req.numelem;
  else {dimtoken=req.numelem; 
        statotoken=req.stato;}
  printf("\nstatotoken=%d\n",statotoken);
  if ((inserimento==1)&&(statotoken==0)) 
	  {printf("\nL'inserimento e' concluso");
	   inserimento=0;
	   close(nextsd);
	   nextsd=nextsd1;
	   sendtknew=0;
	   nextsd1=0;
           nextnodo.len=insertoken[1].sin_port;
	   nextlen=nextnodo.len;
           if(insertoken[1].sin_addr<10)   sprintf(nextnodo.name,"lia%d%d",0,insertoken[1].sin_addr);
           else sprintf(nextnodo.name,"lia%d",insertoken[1].sin_addr);
           printf(" ora sono collegato a %s %d",nextnodo.name,nextlen);
           }
  return(1); /*ok*/
    }
  else return(0);
   
 /*req contiene ora info sulla dim del token che sta per arrivare. Tali info dovranno arrivare alla recv_token che lo leggera' si usa la var globale dimtoken*/
  
}

segnala3()			
  {
  Token_format tok[2];
  Dimtoken_format dimtok; 
  int lung,w_bytes,n;
  
  /*prima si manda il pacchetto con la dimensione*/
  crash=1;
  dimtok.stato=3;
  dimtok.numelem=2;
  dimtok.tkid=-1;
  lung=sizeof(dimtok); /*4 byte*/
  printf("\nSEGNALAZIONE GUASTO\n");
  printf("\nInizio a spedire la dimensione del token con stato=3\n");
  for(w_bytes=0;w_bytes<lung;w_bytes+=n)
     n=send(nextsd,((char*)&dimtok)+w_bytes,lung-w_bytes,0);
  if (n!=lung) {printf("\nProblemi a spedire la dim del token ->Recovery");return(-1);}
  tok[0].sin_port=mylen;
  tok[0].sin_addr=converti((myhost.name+3),2);
  tok[1].sin_port=0;
  tok[1].sin_addr=0;
  lung=sizeof(Token_format)*2;
  printf("\nInizio a spedire il Token generato");
  for(w_bytes=0;w_bytes<lung;w_bytes+=n)
     n=send(nextsd,((char*)&tok)+w_bytes,lung-w_bytes,0);
  if (n!=lung) {printf("\nProblemi a spedire il  token ->Recovery");return(-1);}
  return (n);
}


 void manda_richiesta(Request *cordhost, Request *myhost1,Request *puntnext)
{ int h,n,lung,w_bytes,r_bytes;
  Request appo,appo1;

  appo=*cordhost;
  appo1=*myhost1;
  h=create_nexthost_endpoint(appo.len,appo.name);
  if((lung=sizeof(appo))<=0) printf("Errore lung=%d",lung);
  for(w_bytes=0;w_bytes<lung;w_bytes+=n)
     n=send(h,((char*)myhost1)+w_bytes,lung-w_bytes,0);
  if(n!=lung) { 
	 	printf("\nProblemi per spedire i miei dati al cordinatore\n");
                exit(1); 
              }
  else shutdown(h,1);
  if((lung=sizeof(appo))<=0) printf("problemi con la richiesta da spedire %d/n",lung);
  for(r_bytes=0;r_bytes<lung;r_bytes+=n)
     {
     n=recv(h,((char*)puntnext)+r_bytes,lung-r_bytes,0);
     if(n<0) {perror("problemi sulla connessione"); 
	      exit(0);
 	     } 
     }
  if(n!=lung) { printf("\nProblemi per ricevere i dati dal cordinatore\nho ricevuto solo %d byte = %s",n,nextnodo.name);
                exit(1); 
              }
  else shutdown(h,0);
    nextnodo.len=puntnext->len;
    strcpy(nextnodo.name,puntnext->name);	
    printf("\nHo ricevuto dal coordinatore:%s  %d",nextnodo.name,nextnodo.len);
  
}


/*Servitore concorrente con connessione*/

int main(argc,argv)
int argc;
char **argv;
{ struct sockaddr_in peeraddr_in;/*info sul nodo successivo del ring*/
  struct sockaddr_in precaddr_in;/*info sul nodo precedente nel ring*/

 HANDLE ricevi,listener,maxhp1,pidric,pidtok, collegato_next,inizio,addrlen,ret,rcvtk1,apporcv,pidn;
 int portar,portat,nexthostport,creazione,stato,tknew;
 char nexthost[6],reqhost[6],thishost[6];
 fd_set read_hs,temp_hs;
 Request cordhost,*puntnext; 

 printf("\nDigita il nome della macchina di esecuzione");
 scanf("%s",thishost);
 printf("\nDigita il nome della macchina alla quale fare richiesta di inserim. nel ring");
 scanf("%s",reqhost); 
 printf("\nDigita il numero di porta alla quale inviare la richiesta:"); 
 scanf("%d",&portar);

  printf("\nDigita il numero di porta sulla quale gestire il token:"); 
 scanf("%d",&portat);
 

 memset((char*)&peeraddr_in,0,sizeof(struct sockaddr_in));
 memset((char*)&precaddr_in,0,sizeof(struct sockaddr_in));
 unlink("book");
 if(mknod("book",S_IREAD|S_IWRITE|S_IFIFO|O_APPEND,0000)<0)
 {perror("mknod"); exit(0);}


 
if((pidn=fork())<0) exit(1);
if(pidn>0) exit(0);

else
{
setsid();
/*chdir("/"); */
umask(0);
/*  for(i=0;i<_NFILE;i++) close(i);*/
/*figlio che gestisce la socket sulla quale dovra' arrivare la richiesta di collegamento dal parte del coordinatore per costituire il ring elementare*/
 
/*figlio che gestisce il token*/
 if ((pidtok=fork())==0)
 { 
   cordhost.len=portar;
   strcpy(cordhost.name,reqhost);
   myhost.len=portat;
   mylen=portat;	 
   strcpy(myhost.name,thishost); 
   printf("\nTento l'inserimento nel ring con i dati %d  %s host %d",myhost.len,cordhost.name,cordhost.len);
   ricevi=create_server_endpoint(myhost.len); 
   puntnext=(Request *)malloc(sizeof(Request)); 
   manda_richiesta(&cordhost,&myhost,puntnext); 	
   nexthostport=puntnext->len;
   strcpy(nexthost,puntnext->name);
   nextnodo.len=puntnext->len;
   nextlen=nextnodo.len;    
   strcpy(nextnodo.name,puntnext->name);   
   /*a questo punto conosco il nodo a cui collegarmi*/
   collegato_next=0;
   printf("\nho inviato la richiesta e ");
   nextsd=create_nexthost_endpoint(nexthostport,nexthost);  
   if (nextsd!=0)
          { 
            printf("\n Mi sono collegato con il nodo con la connessione %d\n",nextsd);
            collegato_next=1;
            getsockname(nextsd,(struct sockaddr*)&peeraddr_in,&addrlen); 	    	
          }
   else 
	 {
	printf("non riesco a collegarmi con il nodo successivo");
	exit(1);
         }

  maxhp1=ricevi+1;
  FD_ZERO(&read_hs);
  FD_ZERO(&temp_hs);
  FD_SET(ricevi,&read_hs);
  FD_SET(ricevi,&temp_hs);
  temp_hs=read_hs;
  close(stdin);
  close(stderr); 
  sigset(SIGCHLD,SIG_IGN); 
  inizio=1;
  addrlen=sizeof(struct sockaddr_in); 
  rcvtk1=0; 
  for(;;)
  { 
    select(maxhp1,&temp_hs,0,0,(struct timeval*)0);
    if ((ricevi+1)<maxhp1)
    {  
       if(FD_ISSET(ricevi,&temp_hs)) 
           { /*significa che e' arrivata una richiesta di connessione di un nuovo nodo (forse non serve)*/
             printf("\nArrivo di nuova richiesta");
           }
        if (FD_ISSET(rcvtk,&temp_hs))     /*e' arrivata la dim del token*/
        {
	   tknew=0;
	   if (statotoken==0) tknew=1;
           sleep(3);

          if ((ret=handledim(rcvtk,nextsd))<0) 
              { printf(" per problemi sulla ricezione della dimensione del token-> recovery ret=%d\n",ret);
	        close(rcvtk);
	        FD_CLR(rcvtk,&read_hs);
                printf("\nTermina il figlio gestore del token");
                exit(0);		
              }			
	  if((ret==0)&&(statotoken!=2)&&(crash==0))
	     {printf(" ret=%d, Segnalo guasto sulla connessione con il mio precedente\n",ret);
	      FD_CLR(rcvtk,&read_hs);
	      segnala3();
	     }
	  if(ret>0)
	  {	
          printf("\ngestione token con stato %d\n",statotoken);
          if ((ret=handletok(rcvtk,nextsd))<=0) 
	    { switch(ret)
		{
	      case -10: {printf("problemi solo sulla nuova connessione");
			 close(nextsd1);
			 FD_CLR(nextsd1,&read_hs);
			 /*azioni conseguenti*/ break;}
 	      case -20: {close(nextsd);
			 FD_CLR(nextsd,&read_hs); 
              		 printf("\nProblemi sulla vecchia connessione. Termina il gestore del token");
             		 exit(0); break;  }
	      case -30:	{close(nextsd);
			 close(nextsd1);
			 FD_CLR(nextsd1,&read_hs);
			 FD_CLR(nextsd,&read_hs);
              		 printf("\nProblemi su entrambe le connessioni. Termina il gestore del token");
             		 exit(0);  break;  }
	      default : {perror("Altri problemi");} 		
		}
            }
 	  else if((statotoken==2)&&(ioout==1)) {
						printf("\nEsco dal ring\n");
						exit(0);
						}
      	  }	
       }
           if (FD_ISSET(rcvtk1,&temp_hs)) 
           {  
              sleep(3);
              if ((ret=handledim(rcvtk1,nextsd))<0) 
              { printf("per problemi sulla ricezione del dim del tok recovery ret1=%d",ret);
                close(rcvtk1);
                printf("\nTermina il gestore della dimensione con il nuovo nodo ");
                exit(0);
              }   
              if (ret>0)
              { printf("\ngestione token ricevuto dal nuovo nodo\n");
                sleep(3);
		if(crash>0) { 
			    if((ret=handletok(rcvtk1,nextsd))>0) crash=0;
			     printf("\nrecovery concluso,nuova connessione %d",rcvtk1);
			     ok_token=1;} 
		else
                if ((ret=handle_new_tok(rcvtk1,nextsd))<=0) 
                { ok_token=0;
                  printf("per problemi sulla ricezione del token recovery ret1=%d",ret);
                  close(rcvtk1);
                  printf("\nTermina il gestore del token1");
                  exit(0);
                }
                else ok_token=1;	    
            }  
           }
          if(changecon)
		{
	      apporcv=rcvtk; 
	      FD_CLR(rcvtk,&read_hs);
    	      close(rcvtk); 
              rcvtk=rcvtk1;
	      rcvtk1=apporcv;     
              changecon=0;
		}	  

          if ((tknew)&&(ok_token)) /*ho ricevuto token da due connessioni*/
	      {
		changecon=1;
		tknew=ok_token=0;
              }        
    }
    if((FD_ISSET(ricevi,&temp_hs)) && (ricevi+1==maxhp1))
 	/*Non mi interessa indirizzo di chi si collega a me (mi interessera'!)*/
 	{       printf("\nArrivo tentativo di collegamento\n");
                rcvtk=accept(ricevi,0,0);
    		FD_SET(rcvtk,&read_hs);
 		if(maxhp1<=rcvtk) maxhp1=rcvtk+1;
        /*a questo punto e' stata accettata la connessione con il coordinatore (si e' costituito un lato del token, ora bisognera' stabilire l'altro)*/
         
              getsockname(rcvtk,(struct sockaddr*)&precaddr_in,&addrlen);
              printf("\nRicevuto il collegamento dal nodo precedente sulla porta %u",precaddr_in.sin_port);
 	}
    else if ((FD_ISSET(ricevi,&temp_hs)) && (ricevi+1<maxhp1))
 /*vera quando si effettua il secondo collegamento 
   Non mi interessa indirizzo di chi si collega a me */
 	{       printf("\n\nNUOVA CONNESSIONE");
 		rcvtk1=accept(ricevi,0,0);
 		FD_SET(rcvtk1,&read_hs);
 		if(maxhp1<=rcvtk1) maxhp1=rcvtk1 + 1;
                printf("\n\nEFFETTUATA con rcvtk1=%d",rcvtk1);
                getsockname(rcvtk1,(struct sockaddr*)&precaddr_in,&addrlen);
		if ((precusc==1)||(crash==1))			
  	 		       {     
				if(rcvtk!=rcvtk1)
				{		                         
				close(rcvtk);
		      	        FD_CLR(rcvtk,&read_hs);
				}
				printf("ho effettuato il cambio di connessione %d-->%d\n",rcvtk,rcvtk1);
				rcvtk=rcvtk1;
 				rcvtk1=0;				
			       }
      	}
    temp_hs=read_hs;
     
  }
 }


else exit(0);
 }
}/*Main*/ 

