
/* Programma coordinatore al quale fanno capo due processi figli che hanno il compito rispettivamente di gestire la circolazione del token e le richieste di accesso alla risorsa. 
Seguono entrambi la struttura di server concorrente sequenziale che utilizza gli asincronismi della primitiva select per simulare il parallelismo senza generare ulteriori figli.

Va mandato in esecuzione solo dopo aver attivato il "Gestore" della risorsa.*/ 



#include <sys/types.h>
#include <sys/socket.h>
#include <errno.h>
#include <netinet/in.h>
#include <stdio.h>
#include <netdb.h>
#include <signal.h>
/*#include <unistd.h>*/
#include <sys/ipc.h>
#include <sys/stat.h>
#include <fcntl.h>
#define NAMES 10
#define LEN 50
typedef struct {u_short len; char name[6];} Request;
typedef struct {u_short sin_port;u_long sin_addr;} Token_format; /*size=6*/
typedef struct {u_short stato;u_short numelem;u_long tkid;} Dimtoken_format; /*size=4*/
typedef struct hostent Hostent;
struct elemento {u_short sin_port;u_long sin_addr; struct elemento *next;} list_entry;  struct elemento *ptoken,*piniz,*pfine;

Token_format arraytoken[LEN],insertoken[2];
typedef int HANDLE;
Request nextnodo,myhost;
long ciclo,dimtoken,idtoken=0; /*dimensione e identificatore del token*/
u_long indirizzo;u_short statotoken,inserimento=0;
int nextsd,nextsd1,sendtknew=0,x=0,ipcsd,sdris,portrissec,cambiato_nextsd=0,crash=0;
u_short stato_risorsa,nextlen,mylen;

/*FUNZIONE*/

void hand(int signo)	
 {			 	
int stato;
printf("E' morto uno dei figli\n");
 }

HANDLE create_server_endpoint(int port)
{
struct sockaddr_in addr;
static HANDLE h;

h=socket(AF_INET,SOCK_STREAM,0);
memset((void*)&addr,0,sizeof(addr));
addr.sin_family=AF_INET;
addr.sin_port=htons(port);
addr.sin_addr.s_addr=INADDR_ANY;
bind(h,(struct sockaddr*)&addr,sizeof(addr));
listen(h,5);
return h;
}

HANDLE create_nexthost_endpoint(int port, char *nomehp)
{struct sockaddr_in addr;
 struct hostent *hp;
 static HANDLE h;

hp=(Hostent *)malloc(sizeof(Hostent)); 
h=socket(AF_INET,SOCK_STREAM,0);
if(h==-1)
{  fprintf(stderr,"Impossibile aprire socket \n");
   fflush(stdout); 
   return 0;
}
hp=gethostbyname(nomehp);
if(hp==NULL)
   {fprintf(stderr,"%s non trovato in /etc/hosts\n",nomehp);
    fflush(stdout); 
    return 0;
   }

memset((void*)&addr,0,sizeof(addr));
addr.sin_family=AF_INET;
addr.sin_port=htons(port);
addr.sin_addr.s_addr=((struct in_addr*)(hp->h_addr))->s_addr;;
indirizzo=addr.sin_addr.s_addr;
if(connect(h,(struct sockaddr*)&addr,sizeof(struct sockaddr_in))==-1)
{  fprintf(stderr,"Impossibile connettersi a %s sulla porta=%u \n",nomehp,addr.sin_port);
   fflush(stdout); 
   return 0;
}

 return h;
}


/* FUNZIONE che riceve la richiesta*/

int recv_request (HANDLE h,Request *req) 
{
static int r_bytes,n;
int len=sizeof(*req);

for(r_bytes=0;r_bytes<len;r_bytes+=n)
{ n=recv(h,((char*)req)+r_bytes,len-r_bytes,0);
if (n<=0) return n;
}
/*Decodifico len*/
req->len=ntohl(req->len);
printf("\nHo ricevuto 1 campo :(%s) dal client",req->name);
printf("\nHo ricevuto 2 campo :(%d) dal client",req->len);

return r_bytes;
}



/*FUNZIONE di invio risposta al cliente*/

int send_response(int h, Request *risp)
{ Request rispo;
  int lung,w_bytes;
  static int n;

  rispo=*risp;
  lung=sizeof(rispo);
  printf("\nSpedisco (rispo.name=%s) e (rispo.len=%d) ",rispo.name,rispo.len); 

for(w_bytes=0;w_bytes<lung;w_bytes+=n)
   n=send(h,((char*)&rispo)+w_bytes,lung-w_bytes,0);
 return(n);
}

int send_cliep(int h, Token_format *risp)
{ Token_format rispo;
  int lung,w_bytes,n;

   rispo=*risp;
   lung=sizeof(rispo);
   
for(w_bytes=0;w_bytes<lung;w_bytes+=n)
   n=send(h,((char*)&rispo)+w_bytes,lung-w_bytes,0);

 return(n);
}





/*FUNZIONE che attua l'azione*/

 Request *azione(Request *req)
{  Request app;
   app=*req;
   ciclo++;
   app.len=ciclo; /*si chiamera' una funz che restituira' il num di porta*/
   strcpy(app.name,"bene");/*funz per l'indirizzo*/
   req=&app;
   return(req);
}





 
/*FUNZIONE che riceve la richiesta, attua l'azione e manda la risposta*/

int handle(HANDLE h) 
{
Request req,*risp;

risp=(Request *)malloc(sizeof(Request)); 
if(recv_request(h,&req)<=0) return 0;
/*Vuol dire che cliente e' disconnesso */
risp=azione(&req);
return send_response(h,risp);
}
  

int send_token(HANDLE h, Token_format *tkout)
{ Dimtoken_format dimout;
  int lung,w_bytes;
  static int n;
     

   dimout.stato=statotoken;    
   dimout.numelem=2;	
   dimout.tkid=idtoken; 
   if (h!=nextsd) dimout.stato=0;
  lung=sizeof(dimout);
   printf("\nSpedisco la dimensione del %d token che vale %d e stato %d",dimout.tkid,dimtoken,dimout.stato);

   for(w_bytes=0;w_bytes<lung;w_bytes+=n)
     {
     n=send(h,((char*)&dimout)+w_bytes,lung-w_bytes,0);
     if(n==0) w_bytes=lung+1;
     }
  if(n!=lung) { printf("\nProblemi per spedire la dimensione del token -> Recovery");
                return(-1);
              }
  else
  {  
    lung=sizeof(*tkout)*2;
    printf("\nSpedisco il %d Token\n\n\n",dimout.tkid); 

    for(w_bytes=0;w_bytes<lung;w_bytes+=n)
       {
       n=send(h,((char*)tkout)+w_bytes,lung-w_bytes,0);
       if(n==0) w_bytes=lung+1;
       }
  
    if(n!=lung) { printf("\nProblemi per spedire il token -> Recovery");
                  return(-1);
                }
    else return(n);
         
  }
}

int converti(char *buf,int step)
{ static int i;
  char *ris,app5[6],app2[3];

  ris=(char *)malloc(step);
  if(step==2)
   {
  for(i=0;i<step;i++) app2[i]=buf[i];
       sprintf(ris,"%s\n",app2);       

   }
  else {
       for(i=0;i<step;i++) app5[i]=buf[i];
       sprintf(ris,"%s\n",app5);       
       }
  return (atoi(ris));
}


/*Questa funzione dovra' creare la lista delle richieste pendenti partendo dal contenuto del token arrivato */

 liaxx(int ind,char buf[5])
     {
 if(ind<=9) sprintf(buf,"lia0%d",ind);
	else sprintf(buf,"lia%d",ind);
     }	
 

 Token_format *azione_token(Token_format *tkin)
{  Token_format app;
   int i,nextname,myname;
   char buf[5];
   printf("\nIl contenuto del token e' ....\n");
   for(i=0;i<dimtoken;i++)
      printf("\n(%d)  Elemento sin_port=%u   sin_addr=%u",i,arraytoken[i].sin_port,arraytoken[i].sin_addr);

       nextname=converti((nextnodo.name+3),3);
       myname=converti((myhost.name+3),3);

     if (statotoken==1)
     {        
	if(arraytoken[0].sin_port)
	{
	printf("\nIl nodo che deve cambiare istradamento e': lia%d  porta=%d",arraytoken[0].sin_addr,arraytoken[0].sin_port);
       printf("\nIl nodo da inserire e': lia%d  porta=%d",arraytoken[1].sin_addr,arraytoken[1].sin_port);
 	}     
       if((mylen==arraytoken[1].sin_port)&&(myname==arraytoken[1].sin_addr))
       { inserimento=2;
         printf("\n sono %s e devo ricevere da una nuova connessione ",myhost.name);
       }
       if((nextlen==arraytoken[0].sin_port)&&(nextname==arraytoken[0].sin_addr))
        {
        inserimento=1;
         printf("\nDevo cambiare l'istradamento");
          insertoken[0].sin_port=arraytoken[0].sin_port;/*e' il mio nexthostendpoint*/
         insertoken[0].sin_addr=arraytoken[0].sin_addr;
         insertoken[1].sin_port=arraytoken[1].sin_port;/*e' l'endpoint del nuovo nodo*/
         insertoken[1].sin_addr=arraytoken[1].sin_addr;
         }
      }
     else if(statotoken==2)   /*nodo precedente esce*/
		   {
		  printf("Esce %d - e interessa %d lia%d%d\n",arraytoken[0].sin_port,arraytoken[1].sin_port,arraytoken[1].sin_addr);		
		  if((mylen==arraytoken[1].sin_port)&&(myname==arraytoken[1].sin_addr))
			printf("Il mio precedente se ne vuole andare?!\nImpossibile c'e' un errore\n");	
		  if((nextlen==arraytoken[0].sin_port)&&(nextname==arraytoken[0].sin_addr))
			{
			printf("Il nodo successivo vuole uscire dal ring\n");
		        if ((arraytoken[1].sin_addr)<=9)  sprintf(buf,"lia%d%d",0,arraytoken[1].sin_addr);
          		else sprintf(buf,"lia%d",arraytoken[1].sin_addr);
			
		   	nextsd=create_nexthost_endpoint(arraytoken[1].sin_port,buf);
                        cambiato_nextsd=1;
			printf("Il nuovo nodo e' lia%d %d con connessione %d\n",arraytoken[1].sin_addr,arraytoken[1].sin_port,nextsd);  
			 /*aggiorno l'endpoint del mio successivo*/
                        nextlen=arraytoken[1].sin_port;
                        nextname=arraytoken[1].sin_addr;
			nextnodo.len=nextlen;
			liaxx(nextname,nextnodo.name);

			}
                   }
     return(tkin);
}

 
int recv_dimtoken(HANDLE h,Dimtoken_format *req) 
{
static int r_bytes,n;
int len=sizeof(*req);
 
for(r_bytes=0;r_bytes<len;r_bytes+=n)
{ n=recv(h,((char*)req)+r_bytes,len-r_bytes,0);
if (n<=0) return n;
}
if(req->stato!=3)
	{
statotoken=ntohl(req->stato);
idtoken=ntohl(req->tkid);
	}
else statotoken=0;

dimtoken=ntohl(req->numelem);
printf("\n E' arrivato il token: %d %d\n",idtoken,ntohl(req->tkid));
	
return r_bytes;
}


/* FUNZIONE che riceve il token*/
int recv_token(HANDLE h,Token_format *tkin) 
{
int r_bytes,n,numelem,i;
int len=sizeof(*tkin)*dimtoken;
      
     for(r_bytes=0;r_bytes<len;r_bytes+=n)
      { n=recv(h,((char*)tkin)+r_bytes,len-r_bytes,0);
        if (n<=0) return n;
      }
return (r_bytes);
}


int genera_token(HANDLE verso)
{ 
  Token_format tok;
  Dimtoken_format dimtok; 
  int lung,w_bytes;
  static int n;
  
  
  /*prima si manda il pacchetto con la dimensione*/
  dimtok.stato=0;/*assumera' un significato*/
  dimtok.numelem=1;/*il token inizialmente e' vuoto trasporta solo se stesso*/
  lung=sizeof(dimtok); /*4 byte*/
  printf("\nSpedisco la dimensione del token ");
  for(w_bytes=0;w_bytes<lung;w_bytes+=n)
     n=send(verso,((char*)&dimtok)+w_bytes,lung-w_bytes,0);
  if (n!=lung) {printf("\nProblemi a spedire la dim del token ->Recovery");return(-1);}
                
  /*e dopo si manda il token vero e proprio*/
  tok.sin_port=0;
  tok.sin_addr=indirizzo;
  lung=sizeof(tok);
  printf("\nSpedisco il Token generato");
  for(w_bytes=0;w_bytes<lung;w_bytes+=n)
     n=send(verso,((char*)&tok)+w_bytes,lung-w_bytes,0);
  if (n!=lung) {printf("\nProblemi a spedire il  token ->Recovery");return(-1);}

  return (n);
}

passat(Token_format *tkin)
{
static int n=0;
int i;
char *buf;

    buf=(char *)malloc(10);
    for(i=2;i<dimtoken;i++)
       {
       if((tkin[i].sin_addr)<=9) sprintf(buf,"lia%d%d%d",0,tkin[i].sin_addr,tkin[i].sin_port);
       else  sprintf(buf,"lia%d%d",tkin[i].sin_addr,tkin[i].sin_port);
       n=write(ipcsd,buf,10);
       if(n<0) perror("Errore di scrittura nel passaggio delle prenotazioni tra i figli");
	else printf("\nScrivo %d byte nell'IPC:%s %d %d",n,buf,tkin[i].sin_addr,tkin[i].sin_port); 
    if((n!=10)&&(n>0)) { printf("\nProblemi per spedire il token -> Recovery");
                  return(-1);
                }   
       }
    return(n);

}

int send_token3(HANDLE h, Token_format *tkout)		
{ Dimtoken_format dimout;
  int lung,w_bytes;
  static int n;

  dimout.stato=3;    
  dimout.numelem=2; 
  dimout.tkid=-1;
  lung=sizeof(dimout);
   printf("\nSpedisco il token di segnalazione guasti con stato %d\n",statotoken); 
  for(w_bytes=0;w_bytes<lung;w_bytes+=n)
     n=send(h,((char*)&dimout)+w_bytes,lung-w_bytes,0);
  if(n!=lung) { printf("\nProblemi per spedire la dimensione del token -> Recovery");
                return(-1);
              }
  else
  { 
    lung=sizeof(*tkout)*2;
    

    for(w_bytes=0;w_bytes<lung;w_bytes+=n)
        n=send(h,((char*)tkout)+w_bytes,lung-w_bytes,0);
  
    if(n!=lung) { printf("\nProblemi per spedire il token -> Recovery");
                  return(-1);
                }
   
    else return(n);
  }
}


 int handletok(HANDLE h, HANDLE nexth)
 { Token_format *tkin,*tkout;/*puntatori al token da ricevere e spedire*/
   char nomehp[5];
   int apposd,ret,y=0,k;

   tkin=(Token_format *)malloc(sizeof(Token_format));
   tkout=(Token_format *)malloc(sizeof(Token_format));
   if(crash==0) tkin=arraytoken;
   if((ret=recv_token(h,tkin))<=0) {printf("\nhandletok ritorna %d",ret);
			            return ret;
				    }
   if(crash==2)			
	{	printf("\n1)lia%d %d\n",tkin->sin_addr,tkin->sin_port);
		printf("controllo se sono interessato lia%d %d...",(tkin+1)->sin_addr,(tkin+1)->sin_port);
        if((mylen==(tkin+1)->sin_port)&&(converti((myhost.name+3),2)==(tkin+1)->sin_addr))
		{
		liaxx(tkin->sin_addr,nomehp);
		nextsd=create_nexthost_endpoint(tkin->sin_port,nomehp);
		if(nextsd>0)
		printf("Recovery da crash riuscita\nconnesso a %s %d\n",nomehp,tkin->sin_port);
		else perror("problemi nel tentativo di recovery\n");
		crash=0;
 		nextlen=tkin->sin_port;
	        nextnodo.len=nextlen;
                nexth=nextsd;
		strcpy(nextnodo.name,nomehp);
		printf("Invio di nuovo il token %d\n",idtoken);
		}
        else {
	      printf("no\nPasso il token\n");
	      return send_token3(nexth,tkin);		
	     }
	}
   tkout=azione_token(tkin);
   if (cambiato_nextsd) { 
                          printf("\nInvio al nuovo nodo");
                          nexth=nextsd;
                          cambiato_nextsd=0;
                        }

   else printf("\nInvio al solito nodo\n");
   
   passat(tkout); 
   k=send_token(nexth,tkout);
   if(k<0) 
	{
	perror("non riesco a spedire recovery");/*errore*/
	}
   if(k==0)		/*&&inserimento in atto*/
        {
	perror("");
	printf("Cambio l'istradamento\n");
	statotoken=0;/*cosi' cambia anche dimout.stato da inviare al nuovo nodo*/
	send_token(nextsd1,tkout);
        }
   
   if((statotoken==1)&&(!x)) x=k;
   ret=k;
   if (inserimento!=0)
      { 
      if (inserimento==2)
          {
	  /*non occorre sviluppare la parte per ricevere da una nuova connessione */
          }
    
      if (inserimento==1)
          { 
          if ((insertoken[1].sin_addr)<=9)  sprintf(nomehp,"lia%d%d",0,insertoken[1].sin_addr);
          else sprintf(nomehp,"lia%d",insertoken[1].sin_addr);
          
	  if(nextsd1==0) if((nextsd1=create_nexthost_endpoint(insertoken[1].sin_port,nomehp))<0)
			  printf("\n Non riesco a collegarmi"); 
else  printf("Collegamento DA lia%d porta=%d A lia%d",insertoken[0].sin_addr,insertoken[0].sin_port,insertoken[1].sin_addr,insertoken[1].sin_port);
			 /*recovery*/
          if((nextsd1>0)&&(sendtknew==0))          
               	{ 
   	        printf("\n Invio il token al nuovo nodo");
	        y=send_token(nextsd1,tkout);
		sendtknew=y;
	        if((inserimento!=1)||((inserimento==1)&&(x==y))) ret=x;  /*tutto ok*/
   		else if((y!=x)&&(x>0)) ret=-10;      /* problemi solo sulla nuova connessione (si assume che la vecchia connessione sia piu' affidabile)*/
        	     else if((x<=0)&&(y>=0)) ret=-20; 

/*problemi solo sulla vecchia connessione*/
	                  else ret=-30;        /*x<=0 and y<=0 problemi su entrambe le connessioni*/ 
		 x=0;
  	         }
	    }	                      
      	}
   return(ret);
  }
   
  



int handledim(HANDLE h, HANDLE nexth)
{ Dimtoken_format req;
  static int ret;

  if((ret=recv_dimtoken(h,&req))<=0) 
				     {printf("\nhandledim ritorna %d",ret);
 				     if(ret==0) printf(" connessione chiusa ret=%d\n",ret);
				     printf("E' caduto cordtok -> Recovery...");
				     return ret;
				     }
  if(req.stato==3)
		{
		crash=2;
		printf("Possibili problemi nel ring\n");
		return ret;
		}
  else crash=0; /*token normale*/
 
  printf("\n Ho ricevuto la dimensione del %d TOKEN e vale %u",idtoken,req.numelem);
  printf("\ned anche il suo stato=(%u)",req.stato);
  dimtoken=req.numelem; 
  statotoken=req.stato;
  if ((inserimento==1)&&(statotoken==0)) 
  {
   printf("\nL'inserimento e' concluso.Cambio l'istradamento verso:");
   printf(" lia%d porta=%d\n",insertoken[1].sin_addr,insertoken[1].sin_port);
   inserimento=0;
   close(nextsd);
   nextsd=nextsd1;
   sendtknew=0;
   nextsd1=0;
   nextnodo.len=insertoken[1].sin_port;
   nextlen=nextnodo.len;
   if(insertoken[1].sin_addr<10)  
  	sprintf(nextnodo.name,"lia%d%d",0,insertoken[1].sin_addr);
   else sprintf(nextnodo.name,"lia%d",insertoken[1].sin_addr);
   printf(" ora sono collegato a %s %d",nextnodo.name,nextnodo.len);
   }
  return (1); /*ok*/
 
 /*req contiene ora info sulla dim del token che sta per arrivare. Tali info dovranno arrivare alla recv_token che lo leggera' si usa la var globale dimtoken*/
}
 
int recv_cliep (int h,Token_format *req) 
{static int r_bytes,n;
 int len=sizeof(*req);
 for(r_bytes=0;r_bytes<len;r_bytes+=n)
 { n=recv(h,((char*)req)+r_bytes,len-r_bytes,0);
   if (n<=0) {printf("\nErrore nella receive");
              return n;}
  }
/*Decodifico len*/
req->sin_port=ntohl(req->sin_port);
req->sin_addr=ntohl(req->sin_addr);
printf("\nHo ricevuto 1 campo lia:(%d) ",req->sin_addr);
printf("\nHo ricevuto 2 campo :(%d) ",req->sin_port);
return r_bytes;
}
   
int servo_richiesta()
{  int clientsd,w_bytes,r_bytes,lung,n;
   char *cliname;
   Token_format epris,req,esito;

   ptoken=piniz;
   cliname=(char *)malloc(10);
      
   if ((ptoken->sin_addr)<=9)  sprintf(cliname,"lia%d%d",0,ptoken->sin_addr);
          else sprintf(cliname,"lia%d",ptoken->sin_addr);
    req.sin_port=ptoken->sin_port;
    req.sin_addr=ptoken->sin_addr;
    printf("\nE' il turno del cliente : nome=lia%d porta=%d",req.sin_addr,req.sin_port);
    if ((n=send_cliep(sdris,&req))<=0) {printf("\nProblemi con il gestore");
                                       exit(0);}
    printf("\nHo spedito al gestore l'ENDPOINT di tale cliente\n");

        
    if((clientsd=create_nexthost_endpoint(ptoken->sin_port,cliname))<0)
           printf("\n Non riesco a collegarmi"); 
     else 
     { printf("\nMi sono messo in contatto con il cliente con endpoint:");
       printf("macchina=%s porta=%d",cliname,ptoken->sin_port);
       printf("\nImpegno la risorsa!\n");
       stato_risorsa=1;
       epris.sin_port=portrissec;
       epris.sin_addr=converti((myhost.name+3),2);
       lung=sizeof(epris);
       if ((n=send_cliep(clientsd,&epris))<=0) {printf("\nProblemi con il cliente");}
    printf("\nHo spedito al cliente l'ENDPOINT del gestore (lia=%d) (porta=%d) \n",epris.sin_addr,epris.sin_port);

       if(n!=lung) { printf("\nProblemi per spedire l'ENDPOINT");
                     stato_risorsa=0;
                   }
       else
       { 
         printf("\nServizio in corso! Attesa terminazione.....");        
        /*aspetto dal processo gestore un indicazione sulla fine del servizio */
        lung=sizeof(esito);
        if ( (n=recv_cliep(sdris,&esito))<0) {printf("\nerrore esito");}
        if ((esito.sin_port==0) &&(esito.sin_addr==0))
          {printf("\nServizio del cliente terminato correttamente\n");
           close(clientsd);
           stato_risorsa=0;
            return 0;}
        else {printf("\nProblemi sulla risorsa");
               return 1;/*recovery*/}   

 
       
             }    
     }
     return 1;
 }





void crea_lista(Token_format *puntok,int dimtk)
{ int i;struct elemento *elem;
 
  elem=(struct elemento *)malloc(sizeof(list_entry));
  elem->sin_port=puntok[0].sin_port; 
  elem->sin_addr=puntok[0].sin_addr;
  elem->next=NULL;
  printf("\nAggiungo alla lista %d elementi",dimtk);

  if (piniz==NULL) piniz=elem;  
  else  pfine->next=elem;
 
  pfine=elem;  
  for(i=1;i<dimtk;i++)
  { 
    elem=(struct elemento *)malloc(sizeof(list_entry));
    elem->sin_addr=puntok[i].sin_addr;
    elem->sin_port=puntok[i].sin_port;
    elem->next=NULL;
    pfine->next=elem;
    pfine=elem;  /*punta l'ultimo elemento della coda(immissione in coda)*/
  }
}


/*Servitore concorrente con connessione*/

int main(argc,argv)
int argc;
char **argv;
{
  struct sockaddr_in peeraddr_in;/*info sul nodo successivo del ring*/
  struct sockaddr_in precaddr_in;/*info sul nodo precedente nel ring*/
 HANDLE ricevi,listener,maxhp1,pidric,pidtok;
 int portar,portat,nexthostport,creazione,collegato_next, collegato_prec,inizio,addrlen,ret,pidn;
  char nexthost[6],thishost[6];

 fd_set read_hs,temp_hs;

 printf("\nDigita il nome dell'host di esecuzione:"); 
 scanf("%s",thishost);
 printf("\nDigita il numero di porta sulla quale gestire il token:"); 
 scanf("%d",&portat);
 printf("\nDigita il nome dell'host al quale inviare il token:"); 
 scanf("%s",nexthost);
 printf("\nDigita il numero di porta dell'host al quale inviare il token:"); 
 scanf("%d",&nexthostport);
 printf("\nDigita il numero di porta del gestore della risorsa:"); 
 scanf("%d",&portrissec);
 
 memset((char*)&peeraddr_in,0,sizeof(struct sockaddr_in));
 memset((char*)&precaddr_in,0,sizeof(struct sockaddr_in));

if((pidn=fork())<0) exit(1);
if(pidn>0) exit(0);

else
{
setsid();
/*chdir("/"); */
umask(0);
/*  for(i=0;i<_NFILE;i++) close(i);*/

 mylen=portat;
 nextlen=nexthostport;
 ciclo=0; 
 unlink("datitoken");
 if(mknod("datitoken",S_IREAD|S_IWRITE|S_IFIFO,0000)<0)
 {perror("mknod"); exit(0);}
 ipcsd=open("datitoken",O_RDWR);
 if(ipcsd<=0){perror("open");}
 fcntl(ipcsd,F_SETFL,O_NONBLOCK);
 sigset(SIGCHLD,hand);

 if ((pidric=fork())==0)   /*figlio che gestisce la risorsa*/
 { 
   Token_format token[LEN],*puntok;	
   int r_bytes,n,numelem,i,k,stato_risorsa,dati_nuovi;
   int len=sizeof(Token_format)*dimtoken;
   char * buf;

   piniz=NULL;
   pfine=piniz;   
   
   buf=(char *)malloc(10);
   nextnodo.len=nexthostport; 
   strcpy(nextnodo.name,nexthost);
   myhost.len=portat;
   strcpy(myhost.name,thishost);
   sdris=create_nexthost_endpoint(portrissec,myhost.name);
   if (sdris!=0)
          { 
            printf("\n Mi sono collegato con il gestore della risorsa\n");
          }
       else 
          {printf("\nNon riesco a collegarmi con il gestore della risorsa");
           exit(-1);
          }
 
   stato_risorsa=0;
   for(;;)
    {
    i=0;dati_nuovi=0; 
    while((n=read(ipcsd,buf,10))>0)
      { dati_nuovi=1;
        token[i].sin_port=converti((buf+5),5);  	
        token[i].sin_addr=converti((buf+3),2);
        i++;
       }
     puntok=token;
     if (dati_nuovi) { crea_lista(puntok,i);dati_nuovi=0;} 
     ptoken=piniz;
     while(ptoken!=NULL)     /*stampo lista*/
     {  printf("\nLista richieste sospese:%d  %d",ptoken->sin_port,ptoken->sin_addr);
        ptoken=ptoken->next;
     }

     if((stato_risorsa==0)&&(piniz!=NULL)) /*risorsa libera e richieste pendenti*/
      {      k=servo_richiesta();
             sleep(1);
             if (k==0) { piniz=ptoken->next;
                         free(ptoken);
			 printf("\nHo terminato di eseguire la richieste!");
                       }
             if(k==1) printf("\nProblemi sulla risorsa");
           
     }        
     sleep(1);
    }
   
 }
 else
 if ((pidtok=fork())==0)     /*figlio che si occupa della gestione del token*/
  {collegato_next=0;
   collegato_prec=0;
   inizio=1;
   nextnodo.len=nexthostport;
   strcpy(nextnodo.name,nexthost);
   myhost.len=portat;
   strcpy(myhost.name,thishost);
   ricevi=create_server_endpoint(portat); /*crea la socket d'ascolto per il token*/
  
  maxhp1=ricevi+1;
  FD_ZERO(&read_hs);
  FD_ZERO(&temp_hs);
  FD_SET(ricevi,&read_hs);
  FD_SET(ricevi,&temp_hs);
  temp_hs=read_hs;
  close(stdin);
  close(stderr); 
  signal(SIGCHLD,SIG_IGN);
   for(;;)
     { HANDLE rcvtk;
       select(maxhp1,&temp_hs,0,0,(struct timeval*)0);
       if ((ricevi+1)<maxhp1) /*condizione vera se e' stato effettuato il collegamento*/
       {  
         if (FD_ISSET(rcvtk,&temp_hs)) 
	  {    /*e' arrivata la dim del token*/
           sleep(2);
           if ((ret=handledim(rcvtk,nextsd))<0) 
           { printf("per problemi sulla ricezione del dim del tok recovery ret=%d",ret);
	     close(rcvtk);
	     FD_CLR(rcvtk,&read_hs);
             printf("\nTermina il gestore della dimensione ");
             exit(0);  /*Recovery*/
           }
    
	   if(ret>0)	
	   {
           sleep(2);
           if ((ret=handletok(rcvtk,nextsd))<=0) 
            { switch(ret)
		{
	      case -10: {printf("problemi solo sulla nuova connessione");
			 close(nextsd1);
			 FD_CLR(nextsd1,&read_hs);
			 /*azioni conseguenti*/ break;}
 	      case -20: {close(nextsd);
			 FD_CLR(nextsd,&read_hs); 
              		 printf("\nProblemi sulla vecchia connessione. Termina il gestore del token");
             		 exit(0);  /*Recovery e altre azioni*/ break;  }
	      case -30:	{close(nextsd);
			 close(nextsd1);
			 FD_CLR(nextsd1,&read_hs);
			 FD_CLR(nextsd,&read_hs);
              		 printf("\nProblemi su entrambe le connessioni. Termina il gestore del token");
             		 exit(0);  /*Recovery e altre azioni*/ break;  }
	      default : {perror("Altri problemi");} 		
		}
            }
	   }
	  }
       }
      if(FD_ISSET(ricevi,&temp_hs))  /*vera quando si effettua il collegamento*/
 	/*Non mi interessa indirizzo di chi si collega a me */
 	{ 
 		rcvtk=accept(ricevi,0,0);
 		FD_SET(rcvtk,&read_hs);
 		if(maxhp1<=rcvtk) maxhp1=rcvtk + 1;
 /* a questo punto il nodo ha effettuato a sua volta il collegamento, a questo punto il ring e' chiuso*/
                 collegato_prec=1;
 	}

       
     temp_hs=read_hs;
   if ((collegato_prec) && (inizio))
    { /*tento di effettuare il secondo collegamento per completare il ring*/
       nextsd=create_nexthost_endpoint(nexthostport,nexthost);      
       if (nextsd !=0)
          { 
            printf("\n Stabilito collegamento per il ring elementare\n");
            inizio=0;collegato_next=1;
            getsockname(nextsd,(struct sockaddr*)&peeraddr_in,&addrlen);
           }
       else exit(-1);
    }
  }
close(ipcsd);
}
 else {	int i,o;
	wait(&i);
	i=kill(pidric,9);
	o=kill(pidtok,9);
	exit(0);}
 }/*Main*/ 
}

